org.apache.solr.client.solrj.request

## Class RequestWriter

- java.lang.Object
- - org.apache.solr.client.solrj.request.RequestWriter

Direct Known Subclasses:
  BinaryRequestWriter

    public class RequestWriter
    extends Object

A RequestWriter is used to write requests to Solr.

A subclass can override the methods in this class to supply a custom format in which a request can be sent.

Since:
  solr 1.4

### Nested Class Summary

Nested Classes
`static interface` `RequestWriter.ContentWriter`
`static class` `RequestWriter.StringPayloadContentWriter`

### Constructor Summary

Constructors
Constructor and Description
`RequestWriter()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Collection<ContentStream>` `getContentStreams(SolrRequest req)`
`RequestWriter.ContentWriter` `getContentWriter(SolrRequest req)` Use this to do a push writing instead of pull.
`String` `getPath(SolrRequest req)`
`String` `getUpdateContentType()`
`protected boolean` `isEmpty(UpdateRequest updateRequest)`
`protected boolean` `isNull(List l)`
`protected boolean` `isNull(Map l)`
`void` `write(SolrRequest request, OutputStream os)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RequestWriter

    public RequestWriter()

### Method Detail

#### getContentWriter

    public RequestWriter.ContentWriter getContentWriter(SolrRequest req)

Use this to do a push writing instead of pull. If this method returns null `getContentStreams(SolrRequest)` is invoked to do a pull write.

#### getContentStreams

    public Collection<ContentStream> getContentStreams(SolrRequest req)
                                                throws IOException

Throws:
  `IOException`

#### isEmpty

    protected boolean isEmpty(UpdateRequest updateRequest)

#### getPath

    public String getPath(SolrRequest req)

#### write

    public void write(SolrRequest request,
                      OutputStream os)
               throws IOException

Throws:
  `IOException`

#### getUpdateContentType

    public String getUpdateContentType()

#### isNull

    protected boolean isNull(List l)

#### isNull

    protected boolean isNull(Map l)